Imports System.Runtime.InteropServices

Public Class API

    <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)> _
    Public Shared Function GetWindowText(ByVal hwnd As IntPtr, ByVal lpString As System.Text.StringBuilder, ByVal cch As Integer) As Integer
    End Function

    <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)> _
    Public Shared Function GetWindowTextLength(ByVal hwnd As IntPtr) As Integer
    End Function

    <DllImport("user32.dll")> _
    Public Shared Function GetWindowRect(ByVal hWnd As IntPtr, ByRef lpRect As RECT) As Boolean
    End Function

    <DllImport("user32.dll", EntryPoint:="FindWindow", SetLastError:=True, CharSet:=CharSet.Auto)> _
    Public Shared Function FindWindowByCaption( _
    ByVal zero As IntPtr, _
    ByVal lpWindowName As String) As IntPtr
    End Function

    <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)> _
    Public Shared Function PostMessage(ByVal hWnd As IntPtr, ByVal Msg As UInteger, ByVal wParam As UInteger, ByVal lParam As IntPtr) As Boolean
    End Function

#Region " Mouse/Keyboard "

    Public Const MOUSEEVENTF_MOVE As Integer = &H1
    Public Const MOUSEEVENTF_LEFTDOWN As Integer = &H2
    Public Const MOUSEEVENTF_LEFTUP As Integer = &H4
    Public Const MOUSEEVENTF_RIGHTDOWN As Integer = &H8
    Public Const MOUSEEVENTF_RIGHTUP As Integer = &H10
    Public Const MOUSEEVENTF_MIDDLEDOWN As Integer = &H20
    Public Const MOUSEEVENTF_MIDDLEUP As Integer = &H40
    Public Const MOUSEEVENTF_ABSOLUTE As Integer = &H8000

    Public Declare Sub mouse_event Lib "user32" (ByVal dwFlags As Integer, ByVal dx As Integer, ByVal dy As Integer, ByVal cButtons As Integer, ByVal dwExtraInfo As Integer)

    Public Sub MouseClickLeft(ByVal iX As Integer, ByVal iY As Integer, Optional ByVal iMoveSpeed As Integer = 0)
        'Me.mouse_event(MOUSEEVENTF_MOVE Or MOUSEEVENTF_ABSOLUTE, iX, iY, 0, 0)
    End Sub

    Public Structure POINTAPI
        Dim x As Integer
        Dim y As Integer
    End Structure

    ' GetCursorPos: API used to get the current mouse pointer location
    'Parameters
    'lpPoint 
    '[out] Long pointer to a POINT structure that receives the screen coordinates of      
    'the cursor. 
    'Return Values
    'Nonzero indicates success. Zero indicates failure. To get extended error '            
    'information, call GetLastError. 
    'Remarks
    'The cursor position is always given in screen coordinates and is not affected by     
    'the mapping mode of the window that contains the cursor. 
    Public Declare Function GetCursorPos Lib "user32" (ByRef lpPoint As POINTAPI) As Integer
    Private Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long

    'WindowFromPoint: API is used to get the window handle by giving the
    ' location
    '    Parameters
    'Point 
    'Specifies a POINT structure that defines the point to be checked. 
    'Return Values
    'A handle to the window that contains the point indicates success. NULL indicates     'that no window exists at the specified point. A handle to the window under the       'static' text control indicates that the point is over a static text control. 
    Public Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Integer, ByVal yPoint As Integer) As Integer

    Public Declare Sub keybd_event Lib "user32" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)

    Private Const WM_KEYDOWN As Int32 = &H100
    Private Const WM_KEYUP As Int32 = &H101
    Private Const WM_CHAR = &H102
    Public Shared Function PostKey(ByVal sWindowTitle As String, ByVal sKey As Char) As Boolean
        Dim hWnd As IntPtr = FindWindowByCaption(IntPtr.Zero, sWindowTitle)
        If hWnd <> IntPtr.Zero Then
            Return (PostMessage(hWnd, WM_KEYDOWN, Asc(sKey), &H1C0001) And PostMessage(hWnd, WM_CHAR, Asc(sKey), &H1C0001) And PostMessage(hWnd, WM_KEYUP, Asc(sKey), &H1C0001))
        Else
            Debug.WriteLine(sWindowTitle & " not found...")
        End If

        Return False
    End Function

#End Region

#Region " Windows "
    Public Declare Function SetActiveWindow Lib "User32" (ByVal hwnd As IntPtr) As IntPtr
    Public Declare Function GetActiveWindow Lib "User32" () As IntPtr

    'SendMessage: API used to send a message to another window
    '    Parameters
    'hWnd 
    '[in] Handle to the window whose window procedure will receive the message. If        
    'this parameter is HWND_BROADCAST, the message is sent to all top-level windows in    
    'the' system, including disabled or invisible unowned windows, overlapped windows,    
    'and pop'-up windows; but the message is not sent to child windows. 
    'Msg 
    '[in] Specifies the message to be sent. 
    'wParam 
    '[in] Specifies additional message-specific information. 
    'lParam 
    '[in] Specifies additional message-specific information. 
    'Return Values
    'The return value specifies the result of the message processing and depends on       
    'the message sent. 
    Public Declare Function SendMessage Lib "user32" (ByVal hwnd As IntPtr, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As Integer) As Integer

    Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As IntPtr) As IntPtr
    Public Declare Function GetForegroundWindow Lib "user32" () As IntPtr

    Public Structure RECT
        Public Left As Int32
        Public Top As Int32
        Public Right As Int32
        Public Bottom As Int32
    End Structure


    Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Integer) As Integer
    ' SM_CXBORDER, SM_CYBORDER Width and height of a window border, in pixels. This is equivalent to the SM_CXEDGE value for windows with the 3-D look.
    ' SM_CYCAPTION Height of a caption area, in pixels. 

    Public Enum SystemMetricsIndexes
        SM_CXSCREEN = 0
        SM_CYSCREEN = 1
        SM_CXVSCROLL = 2
        SM_CYHSCROLL = 3
        SM_CYCAPTION = 4
        SM_CXBORDER = 5
        SM_CYBORDER = 6
        SM_CXDLGFRAME = 7
        SM_CYDLGFRAME = 8
        SM_CYVTHUMB = 9
        SM_CXHTHUMB = 10
        SM_CXICON = 11
        SM_CYICON = 12
        SM_CXCURSOR = 13
        SM_CYCURSOR = 14
        SM_CYMENU = 15
        SM_CXFULLSCREEN = 16
        SM_CYFULLSCREEN = 17
        SM_CYKANJIWINDOW = 18
        SM_MOUSEPRESENT = 19
        SM_CYVSCROLL = 20
        SM_CXHSCROLL = 21
        SM_DEBUG = 22
        SM_SWAPBUTTON = 23
        SM_RESERVED1 = 24
        SM_RESERVED2 = 25
        SM_RESERVED3 = 26
        SM_RESERVED4 = 27
        SM_CXMIN = 28
        SM_CYMIN = 29
        SM_CXSIZE = 30
        SM_CYSIZE = 31
        SM_CXFRAME = 32
        SM_CYFRAME = 33
        SM_CXMINTRACK = 34
        SM_CYMINTRACK = 35
        SM_CXDOUBLECLK = 36
        SM_CYDOUBLECLK = 37
        SM_CXICONSPACING = 38
        SM_CYICONSPACING = 39
        SM_MENUDROPALIGNMENT = 40
        SM_PENWINDOWS = 41
        SM_DBCSENABLED = 42
        SM_CMOUSEBUTTONS = 43
        SM_SECURE = 44
        SM_CXEDGE = 45
        SM_CYEDGE = 46
        SM_CXMINSPACING = 47
        SM_CYMINSPACING = 48
        SM_CXSMICON = 49
        SM_CYSMICON = 50
        SM_CYSMCAPTION = 51
        SM_CXSMSIZE = 52
        SM_CYSMSIZE = 53
        SM_CXMENUSIZE = 54
        SM_CYMENUSIZE = 55
        SM_ARRANGE = 56
        SM_CXMINIMIZED = 57
        SM_CYMINIMIZED = 58
        SM_CXMAXTRACK = 59
        SM_CYMAXTRACK = 60
        SM_CXMAXIMIZED = 61
        SM_CYMAXIMIZED = 62
        SM_NETWORK = 63
        SM_CLEANBOOT = 67
        SM_CXDRAG = 68
        SM_CYDRAG = 69
        SM_SHOWSOUNDS = 70
        SM_CXMENUCHECK = 71 '/* Use instead of GetMenuCheckMarkDimensions()! */
        SM_CYMENUCHECK = 72
        SM_SLOWMACHINE = 73
        SM_MIDEASTENABLED = 74
        SM_MOUSEWHEELPRESENT = 75
        SM_XVIRTUALSCREEN = 76
        SM_YVIRTUALSCREEN = 77
        SM_CXVIRTUALSCREEN = 78
        SM_CYVIRTUALSCREEN = 79
        SM_CMONITORS = 80
        SM_SAMEDISPLAYFORMAT = 81
    End Enum

    ' Window Styles
    Public Const GWL_STYLE As Integer = -16
    Public Const WS_DLGFRAME As Integer = &H400000
    Public Const WS_CAPTION As Integer = &HC00000
    Public Const WS_THICKFRAME As Integer = &H40000

    Public Const HWND_TOPMOST As Integer = -1&

    Public Const SWP_NOSIZE As Integer = &H1
    Public Const SWP_NOMOVE As Integer = &H2
    Public Const SWP_NOACTIVATE As Integer = &H10
    Public Const SWP_NOZORDER As Integer = &H4
    Public Const SWP_SHOWWINDOW As Integer = &H40

    Public Declare Function SetWindowPos Lib "user32" ( _
        ByVal hwnd As IntPtr, _
        ByVal hWndInsertAfter As Integer, _
        ByVal x As Integer, _
        ByVal y As Integer, _
        ByVal cx As Integer, _
        ByVal cy As Integer, _
        ByVal wFlags As Integer) As Integer
#End Region

#Region " GDI "
    Public Structure DEVMODE
        Dim dmDeviceName As String
        Dim dmSpecVersion As Integer
        Dim dmDriverVersion As Integer
        Dim dmSize As Integer
        Dim dmDriverExtra As Integer
        Dim dmFields As Integer
        Dim dmOrientation As Integer
        Dim dmPaperSize As Integer
        Dim dmPaperLength As Integer
        Dim dmPaperWidth As Integer
        Dim dmScale As Integer
        Dim dmCopies As Integer
        Dim dmDefaultSource As Integer
        Dim dmPrintQuality As Integer
        Dim dmColor As Integer
        Dim dmDuplex As Integer
        Dim dmYResolution As Integer
        Dim dmTTOption As Integer
        Dim dmCollate As Integer
        Dim dmFormName As String
        Dim dmUnusedPadding As Integer
        Dim dmBitsPerPel As Integer
        Dim dmPelsWidth As Integer
        Dim dmPelsHeight As Integer
        Dim dmDisplayFlags As Integer
        Dim dmDisplayFrequency As Integer
    End Structure

    Public Const HORZRES = 8
    Public Const VERTRES = 10

    Public Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As String, ByRef lpInitData As DEVMODE) As IntPtr
    Public Declare Function DeleteDC Lib "gdi32" (ByVal hDC As IntPtr) As IntPtr

    Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As IntPtr) As IntPtr
    Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As IntPtr, ByVal nWidth As Integer, ByVal nHeight As Integer) As IntPtr

    Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As IntPtr, ByVal nIndex As Integer) As Integer

    Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As IntPtr, ByVal hObject As IntPtr) As IntPtr
    Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As IntPtr) As IntPtr

    'dwRop Constants
    Public Const BLACKNESS = &H42
    Public Const DSTINVERT = &H550009
    Public Const CAPTUREBLT = &H40000000
    Public Const MERGECOPY = &HC000CA
    Public Const MERGEPAINT = &HBB0226
    Public Const NOMIRRORBITMAP = &H80000000
    Public Const NOTSRCCOPY = &H330008
    Public Const NOTSRCERASE = &H1100A6
    Public Const PATCOPY = &HF00021
    Public Const PATINVERT = &H5A0049
    Public Const PATPAINT = &HFB0A09
    Public Const SRCCOPY = &HCC0020
    Public Const SRCAND = &H8800C6
    Public Const SRCERASE = &H440328
    Public Const SRCINVERT = &H660046
    Public Const SRCPAINT = &HEE0086
    Public Const WHITENESS = &HFF0062

    Public Declare Function BitBlt Lib "gdi32" Alias "BitBlt" (ByVal hDestDC As IntPtr, ByVal x As Integer, ByVal y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As IntPtr, ByVal xSrc As Integer, ByVal ySrc As Integer, ByVal dwRop As Integer) As IntPtr
    Public Declare Function GetDesktopWindow Lib "user32" () As IntPtr
    Public Declare Function GetDC Lib "user32" (ByVal hWnd As IntPtr) As IntPtr
    Public Declare Function ReleaseDC Lib "user32" (ByVal hwnd As IntPtr, ByVal hdc As IntPtr) As IntPtr


    Public Structure PCURSORINFO
        Dim cbSize As Integer
        Dim flags As Integer
        Dim hCursor As IntPtr
        Dim ptScreenPos As API.POINTAPI
    End Structure

    Public Const CURSOR_SHOWING As Integer = &H1

    ' Das Icon wird unter Verwendung des vom System definierten
    ' Bildes gezeichnet, nicht mit dem vom Anwender vorgegebenen Bild
    Public Const DI_COMPAT = &H4
    ' Zeichnet das Icon in seiner Originalgre
    ' (cxWidth und cyWidth werden ignoriert)
    Public Const DI_DEFAULTSIZE = &H8
    ' Zeichnet nur die Bilddaten des Icons/Cursors
    Public Const DI_IMAGE = &H2
    ' Zeichnet nur die Maske des Icons/Cursors
    Public Const DI_MASK = &H1
    ' Zeichnet Maske und Bilddaten
    Public Const DI_NORMAL = &H3

    Public Declare Function GetCursorInfo Lib "user32" (ByRef pc As PCURSORINFO) As Integer
    Public Declare Function DrawIconEx Lib "user32" (ByVal hdc As IntPtr, ByVal xLeft As Integer, ByVal yTop As Integer, ByVal hIcon As IntPtr, ByVal cxWidth As Integer, ByVal cyWidth As Integer, ByVal istepIfAniCur As Integer, ByVal hbrFlickerFreeDraw As Integer, ByVal diFlags As Integer) As Boolean
#End Region

#Region " Others "

    Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Integer)

#End Region

End Class
