﻿Option Explicit On
Option Strict On

Imports System.ComponentModel

Namespace Sezz

    Public Class ApplicationSettings

        Private m_bBackgroundMode As Boolean
        Private m_bAlwaysOnTop As Boolean
        Private m_iUpdateInterval As Integer
        Private m_sGatheringKey As String
        Private m_sGatheringResourceName As String
        Private m_iGatheringRange As Integer

        <CategoryAttribute("Client")> Public Property UpdateInterval() As Integer
            Get
                Return m_iUpdateInterval
            End Get
            Set(ByVal value As Integer)
                m_iUpdateInterval = value
            End Set
        End Property

        <CategoryAttribute("Client")> Public Property AlwaysOnTop() As Boolean
            Get
                Return m_bAlwaysOnTop
            End Get
            Set(ByVal value As Boolean)
                m_bAlwaysOnTop = value
            End Set
        End Property

        <DescriptionAttribute("Experimental - Still not fully working, when AION is minimized!"), CategoryAttribute("Client")> Public Property BackgroundMode() As Boolean
            Get
                Return m_bBackgroundMode
            End Get
            Set(ByVal value As Boolean)
                m_bBackgroundMode = value
            End Set
        End Property

        <DescriptionAttribute("Please note: CTRL/ALT/SHIFT is not supported!" & vbCrLf & "Don't forget to bind your gathering macro to that key!"), CategoryAttribute("Gathering")> Public Property GatheringKey() As String
            Get
                Return m_sGatheringKey
            End Get
            Set(ByVal value As String)
                m_sGatheringKey = value
            End Set
        End Property

        <CategoryAttribute("Gathering")> Public Property GatheringResourceName() As String
            Get
                Return m_sGatheringResourceName
            End Get
            Set(ByVal value As String)
                m_sGatheringResourceName = value
            End Set
        End Property

        <CategoryAttribute("Gathering")> Public Property GatheringRange() As Integer
            Get
                Return m_iGatheringRange
            End Get
            Set(ByVal value As Integer)
                m_iGatheringRange = value
            End Set
        End Property

        Public Sub New(ByVal oXMLSettings As Sezz.XML.Settings)
            GatheringResourceName = ApplicationSettingsXML.getValueString("Gathering", "ResourceName", "Mithril", True)
            GatheringKey = ApplicationSettingsXML.getValueString("Gathering", "Key", "2", True)
            BackgroundMode = ApplicationSettingsXML.getValueBoolean("Main", "BackgroundMode", False, True)
            AlwaysOnTop = ApplicationSettingsXML.getValueBoolean("Main", "AlwaysOnTop", False, True)
            UpdateInterval = ApplicationSettingsXML.getValueInteger("Main", "UpdateInterval", 2500, True)
            GatheringRange = ApplicationSettingsXML.getValueInteger("Gathering", "Range", 5, True)
        End Sub
    End Class

End Namespace
