﻿'   Based on AionMemory Entity Class, Copyright © 2009 AionHacker.net
'   http://www.aionhacker.net
'   http://www.assembla.com/spaces/AionMemory

Namespace Sezz.AION

    Public Class Entity
        Implements IDisposable

        Private _iProcessID As Integer

        Private _iID As Integer
        Private _sName As String
        Private _iPointer As Integer
        Private __iPointer As Integer
        Private _iX As Single
        Private _iY As Single
        Private _iZ As Single

        Private Const _STOP As Integer = -842150451 ' 0xCDCDCDCD

        Public Sub New(ByVal iProcessID As Integer, ByVal iPointer As Integer)
            MyBase.New()
            _iPointer = iPointer
            _iProcessID = iProcessID
            InitializeValues()
            Update()
        End Sub

        Public ReadOnly Property ID() As Integer
            Get
                Return _iID
            End Get
        End Property

        Public ReadOnly Property X() As Single
            Get
                Return _iX
            End Get
        End Property

        Public ReadOnly Property Y() As Single
            Get
                Return _iY
            End Get
        End Property

        Public ReadOnly Property Z() As Single
            Get
                Return _iZ
            End Get
        End Property

        Public ReadOnly Property Name() As String
            Get
                Return _sName
            End Get
        End Property

        Public ReadOnly Property Pointer() As Integer
            Get
                Return _iPointer
            End Get
        End Property

        Sub IDisposable_Dispose() Implements IDisposable.Dispose
            Me.Dispose(True)
            System.GC.SuppressFinalize(Me)
        End Sub

        Private Sub Dispose(ByVal disposing As Boolean)
            _sName = Nothing
            _iID = 0
            _iX = 0
            _iY = 0
            _iZ = 0
            _iPointer = 0
            GC.Collect()
        End Sub

        Public Sub Update()
            If (_iPointer <> 0) Then
                Try
                    _iX = Sezz.AION.Memory.ReadFloatValue(_iProcessID, (_iPointer + &H28))
                    _iY = Sezz.AION.Memory.ReadFloatValue(_iProcessID, (_iPointer + &H2C))
                    _iZ = Sezz.AION.Memory.ReadFloatValue(_iProcessID, (_iPointer + &H30))
                    __iPointer = Sezz.AION.Memory.ReadIntegerValue(_iProcessID, (_iPointer + &H1C4))
                    If ((__iPointer <> 0) AndAlso (__iPointer <> _STOP)) Then
                        _sName = Sezz.AION.Memory.ReadStringValue(_iProcessID, (__iPointer + &H36), 40, True)
                        _iID = Sezz.AION.Memory.ReadIntegerValue(_iProcessID, (__iPointer + &H20))
                    End If
                Catch
                    InitializeValues()
                End Try
            Else
                InitializeValues()
            End If
        End Sub

        Private Sub InitializeValues()
            _sName = ""
            _iID = 0
            _iX = 0
            _iY = 0
            _iZ = 0
            __iPointer = 0
        End Sub
    End Class

End Namespace