﻿'   Based on AionMemory EntityList Class, Copyright © 2009 AionHacker.net
'   http://www.aionhacker.net
'   http://www.assembla.com/spaces/AionMemory

Imports System.Collections

Namespace Sezz.AION
    Public Class EntityList
        Implements IEnumerable(Of Entity)

        Private _Game As Sezz.AION.Game

        Private entities As New Dictionary(Of Integer, Entity)()
        Private found As HashSet(Of Integer) = Nothing
        Private Const _STOP As Integer = -842150451 ' 0xCDCDCDCD

        Default Public ReadOnly Property Item(ByVal entityPtr As Integer) As Entity
            Get
                Return entities(entityPtr)
            End Get
        End Property

        Public Sub Update()
            found = New HashSet(Of Integer)()

            Dim entityMap As Integer = Sezz.AION.Memory.ReadIntegerValue(_Game.ProcessID, _Game.GameDllBaseAddress.ToInt64 + &H8EF138)
            Dim entityArray As Integer = Sezz.AION.Memory.ReadIntegerValue(_Game.ProcessID, entityMap + &H48)
            Dim entityArrayCount As Integer = Sezz.AION.Memory.ReadIntegerValue(_Game.ProcessID, entityMap + &H58)

            For iCnt As Integer = 0 To entityArrayCount - 1
                Dim struct1Node As Integer = Sezz.AION.Memory.ReadIntegerValue(_Game.ProcessID, entityArray + (iCnt * 4))
                TraverseNode(struct1Node)
            Next

            ' Remove entities not present in memory anymore
            ' Update entities still present
            ' Add new entities and update them
            Dim entitiesToRemove As New List(Of Integer)()

             For Each Entity In entities.Values
                If found.Contains(Entity.Pointer) Then
                    Entity.Update()
                Else
                    entitiesToRemove.Add(Entity.Pointer)
                End If
            Next

            For Each entityPtr As Integer In entitiesToRemove
                entities.Remove(entityPtr)
            Next

            For Each newEntityPtr As Integer In found.Except(entities.Keys)
                entities(newEntityPtr) = New Sezz.AION.Entity(_Game.ProcessID, newEntityPtr)
            Next
        End Sub

        Private Sub TraverseNode(ByVal nodePtr As Integer)
            Try
                Dim entityPtr As Integer = Sezz.AION.Memory.ReadIntegerValue(_Game.ProcessID, nodePtr + 12)

                If entityPtr = 0 OrElse entityPtr = _STOP OrElse Not found.Add(entityPtr) Then Exit Sub
                
                Dim leftPtr As Integer = Sezz.AION.Memory.ReadIntegerValue(_Game.ProcessID, nodePtr)
                Dim rightPtr As Integer = Sezz.AION.Memory.ReadIntegerValue(_Game.ProcessID, nodePtr + 4)

                If leftPtr <> 0 AndAlso leftPtr <> _STOP Then
                    TraverseNode(leftPtr)
                End If

                If rightPtr <> 0 AndAlso rightPtr <> _STOP Then
                    TraverseNode(rightPtr)
                End If
            Catch
            End Try
        End Sub

        Public Function GetEnumerator() As System.Collections.Generic.IEnumerator(Of Entity) Implements System.Collections.Generic.IEnumerable(Of Entity).GetEnumerator
            Return entities.Values.GetEnumerator()
        End Function

        Public Function GetEnumerator2() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
            Return GetEnumerator()
        End Function

        Public Sub New(ByRef Game As Sezz.AION.Game)
            _Game = Game
        End Sub
    End Class

End Namespace
