﻿Imports System.Runtime.InteropServices

Namespace Sezz.AION

    Public Class Game
        Private _iGameDllBaseAddress As IntPtr
        Private _iProcessID As Integer
        Private _Player As Sezz.AION.Player
        Private _EntityList As Sezz.AION.EntityList
        Public ExperienceToLevel(49) As UInteger

        Public Sub New()
            _iGameDllBaseAddress = IntPtr.Zero
            _iProcessID = 0
            _Player = New Sezz.AION.Player(Me)
            _EntityList = New Sezz.AION.EntityList(Me)

            ' XP/Level
            ' http://mmgoftheory.livejournal.com/2021.html
            ExperienceToLevel(0) = 650
            ExperienceToLevel(1) = 1917
            ExperienceToLevel(2) = 4230
            ExperienceToLevel(3) = 8693
            ExperienceToLevel(4) = 14583
            ExperienceToLevel(5) = 22885
            ExperienceToLevel(6) = 34936
            ExperienceToLevel(7) = 52435
            ExperienceToLevel(8) = 73125
            ExperienceToLevel(9) = 94104
            ExperienceToLevel(10) = 130995
            ExperienceToLevel(11) = 169608
            ExperienceToLevel(12) = 217175
            ExperienceToLevel(13) = 266649
            ExperienceToLevel(14) = 326185
            ExperienceToLevel(15) = 392297
            ExperienceToLevel(16) = 522080
            ExperienceToLevel(17) = 669712
            ExperienceToLevel(18) = 817822
            ExperienceToLevel(19) = 1000147
            ExperienceToLevel(20) = 1235084
            ExperienceToLevel(21) = 1609877
            ExperienceToLevel(22) = 2001924
            ExperienceToLevel(23) = 2348658
            ExperienceToLevel(24) = 2686741
            ExperienceToLevel(25) = 3117416
            ExperienceToLevel(26) = 3602261
            ExperienceToLevel(27) = 4012536
            ExperienceToLevel(28) = 4676472
            ExperienceToLevel(29) = 5828232
            ExperienceToLevel(30) = 6808242
            ExperienceToLevel(31) = 8091124
            ExperienceToLevel(32) = 9689407
            ExperienceToLevel(33) = 12669129
            ExperienceToLevel(34) = 16124465
            ExperienceToLevel(35) = 19742022
            ExperienceToLevel(36) = 26012841
            ExperienceToLevel(37) = 29936163
            ExperienceToLevel(38) = 36147970
            ExperienceToLevel(39) = 42173920
            ExperienceToLevel(40) = 49355480
            ExperienceToLevel(41) = 57959880
            ExperienceToLevel(42) = 64372369
            ExperienceToLevel(43) = 70382402
            ExperienceToLevel(44) = 73867010
            ExperienceToLevel(45) = 84528173
            ExperienceToLevel(46) = 97508511
            ExperienceToLevel(47) = 112426441
            ExperienceToLevel(48) = 128909893
        End Sub

        Public ReadOnly Property ProcessID() As Integer
            Get
                Return _iProcessID
            End Get
        End Property

        Public ReadOnly Property GameDllBaseAddress() As IntPtr
            Get
                Return _iGameDllBaseAddress
            End Get
        End Property

        Public ReadOnly Property Running() As Boolean
            Get
                Return (_iProcessID > 0 AndAlso _iGameDllBaseAddress <> IntPtr.Zero)
            End Get
        End Property

        Public ReadOnly Property Player() As Sezz.AION.Player
            Get
                Return _Player
            End Get
        End Property

        Public ReadOnly Property EntityList() As Sezz.AION.EntityList
            Get
                Return _EntityList
            End Get
        End Property

        Public Sub Initialize()
            Refresh()
        End Sub

        Public Sub Refresh()
            Dim myProcesses As Process()
            Dim bProcessFound As Boolean = False

            Try
                myProcesses = Process.GetProcessesByName("AION.bin")
                If myProcesses.Length > 0 Then
                    _iProcessID = myProcesses(0).Id
                    bProcessFound = True
                End If
            Catch ex As Exception
                bProcessFound = False
            End Try

            If bProcessFound Then
                ' AION Process exists!
                If _iGameDllBaseAddress = IntPtr.Zero Then
                    _iGameDllBaseAddress = Sezz.AION.Memory.GetModuleBaseAddress(ProcessID(), "Game.dll")
                End If
            Else
                ' AION Process not found!
                _iProcessID = 0
                _iGameDllBaseAddress = IntPtr.Zero
            End If
        End Sub

        Public Sub FocusWindow()
            If Not HasFocus() Then
                Dim iAionWindowHandle As IntPtr = API.FindWindowByCaption(IntPtr.Zero, "AION Client")
                If iAionWindowHandle <> IntPtr.Zero Then
                    API.SetForegroundWindow(iAionWindowHandle)
                    API.Sleep(250)
                    If Not HasFocus() Then
                        API.SetForegroundWindow(iAionWindowHandle)
                        API.Sleep(250)
                    End If
                    SendKeys.Send("{HOME}")
                End If
            End If
        End Sub

        Public Function HasFocus() As Boolean
            Dim iActiveWindow As IntPtr = API.GetForegroundWindow()
            Dim length As Integer

            If iActiveWindow <> IntPtr.Zero Then
                length = API.GetWindowTextLength(iActiveWindow)
                If length <> 0 Then
                    Dim sb As New System.Text.StringBuilder("", length + 1)

                    API.GetWindowText(iActiveWindow, sb, sb.Capacity)
                    If sb.ToString() = "AION Client" Then Return True
                End If
            End If

            Return False
        End Function

        Public Sub SendKey(ByVal sKey As Char, ByVal bBackgroundMode As Boolean)
            If bBackgroundMode Then
                API.PostKey("AION Client", sKey)
            Else
                If Not HasFocus() Then FocusWindow()
                SendKeys.Send(sKey)
            End If
        End Sub
    End Class

End Namespace