Module modApplication

    Private oRandomizer As New Random

#Region " Regular Expressions "

    Public Function GetMatches(ByVal sString As String, ByVal sRegularExpression As String) As String()
        Dim oRegExp As New System.Text.RegularExpressions.Regex(sRegularExpression)
        Dim sMatches() As String = {}
        Dim oRegExpMatch As System.Text.RegularExpressions.Group
        Dim iCurrent As Integer = 0

        If oRegExp.IsMatch(sString) Then
            ReDim sMatches(oRegExp.Match(sString).Groups.Count - 1)
            For Each oRegExpMatch In oRegExp.Match(sString).Groups
                sMatches(iCurrent) = oRegExpMatch.Value
                iCurrent += 1
            Next
        End If

        Return sMatches
    End Function

#End Region

#Region " Resources "

    Public Function GetIconResource(ByVal sFileName As String) As Icon
        Return New Icon(System.Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream(Application.ProductName & "." & sFileName))
    End Function

#End Region

#Region " Sleep "

    Public Sub Sleep(ByVal lMilliseconds As Long)
        Dim tEndOfSleep As Date = Now().AddMilliseconds(lMilliseconds)

        While Now < tEndOfSleep
            System.Threading.Thread.Sleep(RandomNumber(50, 150))
            Application.DoEvents()
        End While
    End Sub

    Public Function RandomNumber(ByVal iMinimum As Integer, ByVal iMaximum As Integer) As Integer
        Return oRandomizer.Next(iMinimum, iMaximum + 1)
    End Function

#End Region

#Region " Date/Time Conversion "
    Public Function GetUnixTimestamp(ByVal tDate As DateTime) As Decimal
        Dim tNull As New DateTime(1970, 1, 1, 0, 0, 0, 0)
        Dim tDifference As TimeSpan = tDate - tNull
        Return Math.Floor(tDifference.TotalSeconds)
    End Function
#End Region

End Module
